﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;
using System.Media;

namespace EXEFileSensing
{
    public partial class Process : Form
    {
        public Process()
        {
            InitializeComponent();
            Cancel.Enabled = false;

            

        }
        
        
        private void exe_Click(object sender, EventArgs e)
        {

            Program.InitialDirectory = @"C:\";
            Program.Title = "감시할 프로그램을 설정해주세요";
            Program.FileName = "";
            Program.ShowDialog();
            exe_text.Text = Program.FileName;



        }

        private void go_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process sensing = null;

            if (exe_text.Text == "")
            {
                MessageBox.Show("감시할 프로그램을 선택해 주세요", "감시 알람 메시지", MessageBoxButtons.OK);
            }
            else
            {
                Cancel.Enabled = true;
                go.Enabled = false;

                try
                {
                    sensing = System.Diagnostics.Process.Start(exe_text.Text);
                    do
                    {
                        if (!sensing.HasExited)
                        {
                            sensing.Refresh();
                            if (sensing.Responding)
                            {
                                line.Text = "프로그램을 감시중입니다.";
                            }
                            else
                            {
                                line.Text = "감시중인 프로그램이 종료되었습니다.";
                                SoundPlayer _player = new SoundPlayer(EXEFileSensing.Properties.Resources.critical);
                                _player.Play();
                                MessageBox.Show(new Process() {WindowState = FormWindowState.Maximized, TopMost = true }, "감시중인 프로그램이 종료/응답없음 상태입니다.", "감시 알람 메시지", MessageBoxButtons.OK);

                            }
                        }
                    }
                    while (!sensing.WaitForExit(1000));
                }
                    


                finally
                {
                    if (sensing != null)
                    {
                        sensing.Close();
                    }
                }
            }
        }

            

        private void Cancel_Click(object sender, EventArgs e)
        {
            Cancel.Enabled = false;
            go.Enabled = true;
            line.Text = "감시중인 프로그램이 없습니다.";



        }

        private void 기버ㅗToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }
    }
}
