﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;
using System.Threading;
using System.Management;


namespace EXEFileSensing
{
    public partial class Computer : Form
    {
        private Thread addDataRunner;
        public delegate void addDatadelegate();
        public addDatadelegate adddataDel;

        PerformanceCounter p,m;



        public Computer()
        {
            InitializeComponent();


        }
       
        private void Computer_Load(object sender, EventArgs e)
        {
            
            ThreadStart addDataThreadStart = new ThreadStart(AddDataThreadLoop);
            addDataRunner = new Thread(addDataThreadStart);
            adddataDel += new addDatadelegate(AddData);
            progressBar1.Maximum = 100;
            progressBar2.Maximum = 10000;

            p = new PerformanceCounter();
            p.CategoryName = "processor";
            p.CounterName = "% processor Time";
            p.InstanceName = "_Total";

            m = new PerformanceCounter("memory", "Available MBytes");

            addDataRunner.Start();
        }
                

        private void AddDataThreadLoop()
        {
            while (true)
            {
                progressBar1.Invoke(adddataDel);
                Thread.Sleep(1000);
            }
        }
        public void AddData()
        {
            float usage = p.NextValue();
            cpubox.Text = "현재 PC CPU 사용율은 : " + ((int)usage) + "%";
            progressBar1.Value = ((int)usage);

            float m_usage = m.NextValue() ;
            membox.Text = "현재 PC Memory의 사용가능 용량은 : " + m_usage.ToString("N2") + "Mbyte";
            progressBar2.Value = ((int)m_usage);
        }

        private void Computer_FormClosed(object sender, FormClosedEventArgs e)
        {
            addDataRunner.Abort();
        }
    }
}
